/*	
	instr_def wrapper functions for oisois
	Developer: Algorithmica Research, Magnus Nyström

	INCOMPLETE
*/

option(null: hard);	


//----------------
// [DATABASE] create
//----------------

/*
instr_def from class: is incomplete
instr_def from instrument: have settle_date/code and maturity_date/code
*/
/*-----------------------------------------------------------------------
  func: instr_def_swap_oisois
  ----------------------------------------------------------------------*/
instr_def instr_def_swap_oisois(string 	name ,
								error_info option(nullable) error = null<error_info>) 
option (category: 'Instrument/Interest Rate Swap/ONIndex vs ONIndex')
{	
	try{
		logical	is_class_name;
		..instr_def c = instr_def(name ,is_class_name ,error); 
		c 				= create_instr_def(c, is_class_name, error);		
		QL_FAIL_COND(!null(c) && !c.is_swap_oisois(), "instr_def not an ois-ois", E_INIT);		
		return c;						
	}
	catch {
		CORE_INT.catch_error_info(error,err.type(),err.message(), "instr_def.instr_def_swap_oisois");
		return null<..instr_def>;
	}
}


/*-----------------------------------------------------------------------
  func: instr_def_oisois [NO DATABASE]
  this instr_def will be complete but not date_complete
	arguments:
	instr_def_name: user defined name

note: no mtm yet
  ----------------------------------------------------------------------*/
instr_def instr_def_swap_oisois(string					instr_def_name,	
								string 					settle_code,
								string option(nullable) maturity_code,
								notional_exchg_style option(nullable) not_exchange,
								integer 				pmt_lag,
								integer 				pmt_lag_prin,
								logical option(nullable) is_mtm,
								logical option(nullable) is_mtm_leg1,
								integer 			ois1_cpn_freq,
							    day_count_method 	ois1_day_count_method,
							    string 				ois1_currency,
							    calendar 			ois1_calendar,
							    bd_convention 		ois1_bd_convention,
							    logical 			ois1_eom,
								
								flt_comp_avg_type option(nullable)		ois1_comp_avg,
    							flt_sprd_comp_method option(nullable) 	ois1_spread_comp_method,
    							flt_avg_method option(nullable) 		ois1_avg_method,
								rfr_arrears_type option(nullable) 		ois1_arr_type,
								number option(nullable)					ois1_arr_days,
								logical option(nullable)				ois1_endog_df,
								ir_index 								on1_idx,
								integer 			ois2_cpn_freq,
							    day_count_method 	ois2_day_count_method,
							    string 				ois2_currency,
							    calendar 			ois2_calendar,
							    bd_convention 		ois2_bd_convention,
							    logical 			ois2_eom,
								
								flt_comp_avg_type option(nullable)		ois2_comp_avg,
    							flt_sprd_comp_method option(nullable) 	ois2_spread_comp_method,
    							flt_avg_method option(nullable) 		ois2_avg_method,
								rfr_arrears_type option(nullable) 		ois2_arr_type,
								number option(nullable)					ois2_arr_days,
								logical option(nullable)				ois2_endog_df,
								ir_index 								on2_idx,
								error_info option(nullable) error = null<error_info>)
option (category: 'Instrument/Interest Rate Swap/ONIndex vs ONIndex')
{	
	try{	
		instr_def c = __instr_def_oisois_nodb(instr_def_name,settle_code,maturity_code,not_exchange,pmt_lag,pmt_lag_prin,is_mtm,is_mtm_leg1,
												ois1_cpn_freq,ois1_day_count_method,ois1_currency,ois1_calendar,
							    				ois1_bd_convention, ois1_eom,
												ois1_comp_avg,ois1_spread_comp_method, ois1_avg_method,
												ois1_arr_type,ois1_arr_days,ois1_endog_df, 
												on1_idx,
												ois2_cpn_freq,ois2_day_count_method,ois2_currency,ois2_calendar,
							    				ois2_bd_convention, ois2_eom,
												ois2_comp_avg,ois2_spread_comp_method, ois2_avg_method,
												ois2_arr_type,ois2_arr_days,ois2_endog_df,
												on2_idx);

		return create_instr_def(c, error);							
	}
	catch {
		CORE_INT.catch_error_info(error,err.type(),err.message(), "instr_def.instr_def_swap_oisois");
		return null<instr_def>;
	}
}


/*-----------------------------------------------------------------------
  func: instr_def_swap_oisois   [NO DATABASE]
  this instr_def will be complete but not date_complete
	arguments:
  	note: no mtm yet
  ----------------------------------------------------------------------*/

instr_def instr_def_swap_oisois(INSTR_TMPL.swap_oisois_def_tmpl		tmpl,
								error_info option(nullable) error = null<error_info>)
option (category: 'Instrument/Interest Rate Swap/ONIndex vs ONIndex')
{	
	try{
		logical leg1_mtm;
		logical is_mtm = tmpl.is_mtm(leg1_mtm); 
		instr_def c = __instr_def_oisois_nodb(	tmpl.name(),tmpl.settle_code(),tmpl.maturity_code(),tmpl.not_exchange(),
												tmpl.payment_lag(),tmpl.payment_lag_prin(),is_mtm,leg1_mtm,
												tmpl.ois1_cpn_freq(),tmpl.ois1_day_count_method(),tmpl.ois1_currency(),tmpl.ois1_calendar(),
							    				tmpl.ois1_bd_convention(), tmpl.ois1_eom(),
												tmpl.ois1_comp_avg(),tmpl.ois1_spread_comp_method(), tmpl.ois1_avg_method(),
												tmpl.ois1_arr_type(),tmpl.ois1_arr_days(),tmpl.ois1_endog_df(),
												tmpl.ois1_ir_index(),
												tmpl.ois2_cpn_freq(),tmpl.ois2_day_count_method(),tmpl.ois2_currency(),tmpl.ois2_calendar(),
							    				tmpl.ois2_bd_convention(), tmpl.ois2_eom(),
												tmpl.ois2_comp_avg(),tmpl.ois2_spread_comp_method(), tmpl.ois2_avg_method(),
												tmpl.ois2_arr_type(),tmpl.ois2_arr_days(),tmpl.ois2_endog_df(),
												tmpl.ois2_ir_index());


		return create_instr_def(c, error);							
	}
	catch {
		CORE_INT.catch_error_info(error,err.type(),err.message(), "instr_def.instr_def_swap_oisois");
		return null<instr_def>;
	}
}
/*-----------------------------------------------------------------------
  func: instr_def_swap_oisois   [NO DATABASE]
  this instr_def will be complete but not date_complete
	arguments:
  	note: no mtm yet
  ----------------------------------------------------------------------*/

instr_def instr_def_swap_oisois(INSTR_TMPL.swap_oisois_def_tmpl		tmpl,
								 string option(nullable) 			maturity_code,//override of template value
								error_info option(nullable) error = null<error_info>)
option (category: 'Instrument/Interest Rate Swap/ONIndex vs ONIndex')
{	
	try{
		if(null(maturity_code))
			maturity_code = tmpl.maturity_code();
		
		logical leg1_mtm;
		logical is_mtm = tmpl.is_mtm(leg1_mtm); 
		instr_def c = __instr_def_oisois_nodb(	tmpl.name(),tmpl.settle_code(),maturity_code,tmpl.not_exchange(),
												tmpl.payment_lag(),tmpl.payment_lag_prin(),is_mtm,leg1_mtm,
												tmpl.ois1_cpn_freq(),tmpl.ois1_day_count_method(),tmpl.ois1_currency(),tmpl.ois1_calendar(),
							    				tmpl.ois1_bd_convention(), tmpl.ois1_eom(),
												tmpl.ois1_comp_avg(),tmpl.ois1_spread_comp_method(), tmpl.ois1_avg_method(),
												tmpl.ois1_arr_type(),tmpl.ois1_arr_days(),tmpl.ois1_endog_df(),
												tmpl.ois1_ir_index(),
												tmpl.ois2_cpn_freq(),tmpl.ois2_day_count_method(),tmpl.ois2_currency(),tmpl.ois2_calendar(),
							    				tmpl.ois2_bd_convention(), tmpl.ois2_eom(),
												tmpl.ois2_comp_avg(),tmpl.ois2_spread_comp_method(), tmpl.ois2_avg_method(),
												tmpl.ois2_arr_type(),tmpl.ois2_arr_days(),tmpl.ois2_endog_df(),
												tmpl.ois2_ir_index());


		return create_instr_def(c, error);							
	}
	catch {
		CORE_INT.catch_error_info(error,err.type(),err.message(), "instr_def.instr_def_swap_oisois");
		return null<instr_def>;
	}
}
 

