option(null: hard);	

/*	
	instrument wrapper functions
	Developer: Algorithmica Research, Magnus Nyström	

INCOMPLETE

	--------------------------------------------------------------------
		swap_oisois create funcs
	--------------------------------------------------------------------		
*/

//--------
// from db
//--------


/*-----------------------------------------------------------------------
  swap_oisois
  ----------------------------------------------------------------------*/
swap_oisois swap_oisois(instrument_name 			instrument_name, 
							date option(nullable) 		trade_date 	= null<date>,
							string option(nullable) 	quote_side 	= null<string>,
							error_info option(nullable) error		= null<error_info>)
option (category: 'Instrument/Interest Rate Swap/ONIndex vs ONIndex')
{	
	try{			
		__instrument c = __instrument(instrument_name,trade_date,quote_side, null<date> );		
		return create_swap_oisois(c,error, E_INIT);						
	}
	catch {
		CORE_INT.catch_error_info(error,err.type(),err.message(), "swap_oisois");
		return null<swap_oisois>;
	}
}


/*-----------------------------------------------------------------------
  swap_oisois
  ----------------------------------------------------------------------*/
swap_oisois swap_oisois(instrument_name 			instrument_name, 
							date option(nullable) 		trade_date ,
							number  option(nullable) 	quote ,
							error_info option(nullable) error		= null<error_info>)
option (category: 'Instrument/Interest Rate Swap/ONIndex vs ONIndex')
{	
	try{				
		__instrument c = __instrument(instrument_name,trade_date,quote, null<date> );//if quote is null --> c flagged as err-instrument
		return create_swap_oisois(c,error, E_INIT);							
	}
	catch {
		CORE_INT.catch_error_info(error,err.type(),err.message(), "swap_oisois");
		return null<swap_oisois>;
	}
}


/*-----------------------------------------------------------------------
  swap_oisois
  ----------------------------------------------------------------------*/
swap_oisois swap_oisois(instr_def 					instr_def, 
							date option(nullable) 	trade_date 	= null<date>,
							string option(nullable) quote_side 	= null<string>,
							error_info option(nullable) error		= null<error_info>)
option (category: 'Instrument/Interest Rate Swap/ONIndex vs ONIndex')
{	
	try{				
		__instrument c = __instrument(instr_def,trade_date,quote_side, null<date> );
		return create_swap_oisois(c,error, E_INIT);						
	}
	catch {
		CORE_INT.catch_error_info(error,err.type(),err.message(), "swap_oisois");
		return null<swap_oisois>;
	}
}
/*-----------------------------------------------------------------------
  swap_oisois
  ----------------------------------------------------------------------*/
swap_oisois swap_oisois(instr_def 					instr_def, 
							date option(nullable) 		trade_date ,
							number  option(nullable) 	quote ,
							error_info option(nullable) error		= null<error_info>)
option (category: 'Instrument/Interest Rate Swap/ONIndex vs ONIndex')
{	
	try{			
		__instrument c = __instrument(instr_def,trade_date,quote, null<date> );
		return create_swap_oisois(c,error, E_INIT);						
	}
	catch {
		CORE_INT.catch_error_info(error,err.type(),err.message(), "swap_oisois");
		return null<swap_oisois>;
	}
}

//----------------
// from db or not
//----------------

/*-----------------------------------------------------------------------
  func: swap_oisois
  arguments: 
	instr_def: 	can be created either from the db or user defined 				 
				instr_def is copied and modified
				no lookup of quotes
	instrument_name: user defined name
--> will throw for currency swaps
  ----------------------------------------------------------------------*/
swap_oisois swap_oisois(instr_def 				instr_def, 
							string 					instrument_name  ,
							date option(nullable) 	trade_date ,
							date option(nullable) 	settle_date ,							
							date  option(nullable) 	maturity,//maturity has precedence over mat_code
							string option(nullable) maturity_code,
							number option(nullable)	spread,							
							number 					nominal= 100,
							error_info option(nullable) error		= null<error_info>)
option (category: 'Instrument/Interest Rate Swap/ONIndex vs ONIndex')
{	
	try{
		__instrument c;

		if(!null(maturity))
			c = __instrument_oisois_par_nodb(instr_def,instrument_name,trade_date,settle_date, maturity,spread,nominal );
		else if(!null(maturity_code))
			c = __instrument_oisois_par_nodb(instr_def,instrument_name,trade_date,settle_date, maturity_code,spread,nominal );
		else
			QL_FAIL("invalid maturity/maturity_code");
		return create_swap_oisois( c, error);						
	}
	catch {
		CORE_INT.catch_error_info(error,err.type(),err.message(), "swap_oisois");
		return null<swap_oisois>;
	}
}

//----------------
// no db, not par 
//----------------

/*-----------------------------------------------------------------------
  func: swap_oisois
  ----------------------------------------------------------------------*/
swap_oisois swap_oisois(ql_ois_leg 		ql_ois_leg1,
						ql_ois_leg 		ql_ois_leg2, 
						string 			id,
						error_info option(nullable) error		= null<error_info>)
option (category: 'Instrument/Interest Rate Swap/ONIndex vs ONIndex')
{	
	try{			
		
		__instrument c = __instrument_swap(ql_ois_leg1,ql_ois_leg2,id);

		return create_swap_oisois( c, error);					
	}
	catch {
		CORE_INT.catch_error_info(error,err.type(),err.message(), "swap_oisois");
		return null<swap_oisois>;
	}
}

/*-----------------------------------------------------------------------
  func: swap_oisois
  ----------------------------------------------------------------------*/
swap_oisois swap_oisois(ql_fixed_income_swap ql_fixed_income_swap,
						error_info option(nullable) error		= null<error_info>)
option (category: 'Instrument/Interest Rate Swap/ONIndex vs ONIndex')
{	
	try{	
		QL_FAIL_COND(CORE_INT.swap_instr_type(ql_fixed_income_swap) != instr_type.SWAP_OISOIS, "invalid instrument type");

		__instrument c = __instrument_swap(ql_fixed_income_swap);

		return create_swap_oisois( c, error);						
	}
	catch {
		CORE_INT.catch_error_info(error,err.type(),err.message(), "swap_oisois");
		return null<swap_oisois>;
	}
}


module CORE_INT_OISOIS
{
	/*-----------------------------------------------------------------------
	  func: swap_oisois_plain_int
	  minimal constructor for "screen"-swap  --> NO STUBS
	    normally: leg1 = sprd_leg, leg2 = flat_leg
	  ----------------------------------------------------------------------*/
	swap_oisois swap_oisois_plain_int(	instr_def 					def,
										string 						instrument_name,	
										date option(nullable) 		trade_date,	
										date option(nullable) 		start_date,
										string option(nullable) 	fwd_start_code,
										date 	option(nullable)	maturity,
										string 	option(nullable)	maturity_code,																				
										number option(nullable)		flt1_notional,//ex. EUR 1000000
										number 	 					flt2_notional,//ex. USD 1400000
										number option(nullable)		flt1_spread ,//if null --> will be set to par, spread on leg1
										number option(nullable)		flt2_spread ,//if null --> will be set to 0
										logical 					flt1_pay,
										fx_spot option(nullable)	fx_sp,
										number option(nullable)		fx_quote,//quoted as fx_spot object, ex EURUSD=1.4
										
										..disc_func option(nullable) flt1_disc_func,								
										//fwd_func option(nullable) 	fwd_func_sprd_leg,
										..disc_func option(nullable) flt1_fwd_disc_func,										
										
										..disc_func option(nullable) flt2_disc_func,								
										//fwd_func option(nullable) 	fwd_func_flat_leg,
										..disc_func option(nullable) flt2_fwd_disc_func,										
										
										logical option(nullable)	pv_in_base,
										integer flt1_sprd_rnd_dec,
										error_info option(nullable) error )
	{	
		try{
			CORE_INT.reset_single(error);
			
			QL_FAIL_COND(!def.is_swap_oisois(), "instr_def is not an ois-ois", E_INIT);
			
			logical is_ccy 		= def.is_ccy_swap();
			logical is_mtm 		= def.is_swap_oisois_mtm();
			logical is_mtm_leg1 = def.is_swap_oisois_mtm_leg1();
			//QL_FAIL_COND(is_mtm_leg1, "currently the mtm leg must be leg2", E_INIT);
			
			error_info ee 		= error_info(true,true);
			string flt1_curr	= def.swap_currency_leg1(ee);
			string flt2_curr	= def.swap_currency_leg2(ee);
			notional_exchg_style ne = def.swap_not_exchange(ee);
						
			number flt1_fx_rate ,flt2_fx_rate;
			number fxs_quote_used;
			logical leg1_is_base_ccy;
			date fx_spot_date ;
			
			if(is_ccy) {
				QL_FAIL_COND(null(fx_sp), "fx spot instrument required for cross currency swap", E_INIT);
				fx_spot_date 		= fx_sp.spot_date(ee);
				string base_ccy 	= fx_sp.base_ccy(ee);//ex EUR
				string price_ccy 	= fx_sp.price_ccy(ee);//ex USD
				
				if(null(pv_in_base))
					pv_in_base = true;
				
				fxs_quote_used 	= null(fx_quote) ? fx_sp.quote(true,false,ee) : fx_quote/fx_sp.scale(ee);//ex 1.4
				QL_FAIL_COND(null(fxs_quote_used), "invalid fx_spot quote", E_INIT);

				CORE_INT_FLTFLT.swap_lib_fx_handler_ccy(flt1_curr,flt2_curr,base_ccy,price_ccy,pv_in_base,fxs_quote_used,
										leg1_is_base_ccy, flt1_fx_rate, flt2_fx_rate);							
				//ex pv_in_leg1=true --> flt1_fx_rate = 1, flt2_fx_rate = 1/1.4 = 0.714
				if(null(ne))
					ne 	= NE_BOTH;	
			}
			else {
				fxs_quote_used = flt1_fx_rate = flt2_fx_rate = 1;
				if(null(ne))
					ne 	= NE_NONE;	
			}
						
			//common
			date_code settle_code 			= date_code(def.settle_code());			
			round_code comp_factor_round_code = null<round_code>;			//FIX_ME
			round_code 	imp_rate_pcnt_round_code= null<round_code>;			//FIX_ME
			
			//leg1
			rfr_arrears_type flt1_rfr_arr_type 	= def.swap_rfr_arr_type_leg1();			
			integer flt1_rfr_arr_days 		= def.swap_rfr_arr_days_leg1();					
			integer flt1_pmt_delay			= def.swap_pmt_lag_leg1();
			integer flt1_pmt_delay_prin		= def.swap_pmt_lag_prin_leg1();
			flt_avg_method 	flt1_avg_method	= def.swap_avg_method_leg1();			
			flt_sprd_comp_method flt1_sprd_comp_method	= def.swap_sprd_comp_method_leg1();			
			flt_comp_avg_type flt1_comp_avg_type = def.swap_comp_avg_type_leg1();				
			calendar flt1_pmt_calendar		= def.swap_calendar_leg1(ee);
			bd_convention flt1_pmt_bus_day 	= def.swap_pmt_bus_day_leg1(ee);
			logical	flt1_end_of_month		= def.swap_eom_leg1(ee);
			day_count_method flt1_dc 		= def.swap_dc_method_leg1(ee);			
			coupon_freq  flt1_cpn_freq 		= coupon_freq_from_int(def.swap_coupon_freq_leg1(ee))  ;			
			ir_index flt1_ir_index 			= def.swap_ir_index_leg1(ee);			
			ql_swap_ois_def ois1_def 		= ql_swap_ois_def("ois_def1",flt1_curr,settle_code,flt1_cpn_freq,flt1_dc,
															  flt_roll_method.FLR_STRAIGHT,flt1_pmt_bus_day,
																flt1_pmt_calendar,flt1_end_of_month,flt1_ir_index, null<quote_style>,
																null<round_code>,comp_factor_round_code,imp_rate_pcnt_round_code,
																null<..interest_rule>,
																flt1_pmt_delay,flt1_pmt_delay,flt1_pmt_delay_prin,flt1_pmt_delay_prin,
																flt1_rfr_arr_type,flt1_rfr_arr_days,flt1_comp_avg_type,flt1_sprd_comp_method,
																flt1_avg_method,ne,null<logical> );
								
			//leg2
			rfr_arrears_type flt2_rfr_arr_type 	= def.swap_rfr_arr_type_leg2();		
			integer flt2_rfr_arr_days 		=  def.swap_rfr_arr_days_leg2();	
			integer flt2_pmt_delay			= def.swap_pmt_lag_leg2();
			integer flt2_pmt_delay_prin		= def.swap_pmt_lag_prin_leg2();
			flt_avg_method 	flt2_avg_method	= def.swap_avg_method_leg2();
			flt_sprd_comp_method flt2_sprd_comp_method 	= def.swap_sprd_comp_method_leg2();
			flt_comp_avg_type flt2_comp_avg_type = def.swap_comp_avg_type_leg2() ;
			calendar flt2_pmt_calendar		= def.swap_calendar_leg2(ee);
			bd_convention flt2_pmt_bus_day 	= def.swap_pmt_bus_day_leg2(ee);
			logical	flt2_end_of_month		= def.swap_eom_leg2(ee);
			day_count_method flt2_dc 		= def.swap_dc_method_leg2(ee);			
			coupon_freq  flt2_cpn_freq 		= coupon_freq_from_int(def.swap_coupon_freq_leg2(ee))  ;			
			ir_index flt2_ir_index 			= def.swap_ir_index_leg2(ee);			
			ql_swap_ois_def ois2_def 		= ql_swap_ois_def("ois_def2",flt2_curr,settle_code,flt2_cpn_freq,flt2_dc,
															  flt_roll_method.FLR_STRAIGHT,flt2_pmt_bus_day,
																flt2_pmt_calendar,flt2_end_of_month,flt2_ir_index, null<quote_style>,
																null<round_code>,comp_factor_round_code,imp_rate_pcnt_round_code,
																null<..interest_rule>,
																flt2_pmt_delay,flt2_pmt_delay,flt2_pmt_delay_prin,flt2_pmt_delay_prin,
																flt2_rfr_arr_type,flt2_rfr_arr_days,flt2_comp_avg_type,flt2_sprd_comp_method,
																flt2_avg_method,ne,null<logical> );
			
			//---leg---
			//common
			date  first_cpn_date 			= null<date>;
			date  last_reg_date 			= null<date>;
			vector(date) fixing_dates 		= null<vector(date)>;	
			vector(number) fixing_rates		= null<vector(number)>;
			logical  allow_fwd_fix			= false;
			integer	cpn_roll_day 			= 0;			
			calendar cal 					= calendar(flt1_pmt_calendar,flt2_pmt_calendar);
			date settle_date;
			CORE_INT_FIXFLT.swap_start_date_helper(settle_code,trade_date,cal,fwd_start_code,start_date,settle_date);
			QL_FAIL_COND(null(settle_date),"invalid start date", E_INIT);
			tenor_code mat_code 			= CORE_INT_FIXFLT.swap_maturity_helper(def,maturity, maturity_code);
			
			if(is_ccy){				
				QL_FAIL_COND(null(fx_quote) && settle_date != fx_spot_date,"explicit fx quote required when fx spot date is not equal to settle date", E_INIT);
				
				if(null(flt1_notional)){
					QL_FAIL_COND(start_date != settle_date,"invalid nominal (both nominals must be input when settle date is not equal to start date)", E_INIT);					
				}		
			}

			logical allow_extrap 	= false;
			
			//leg1
			number flt1_fix_proxy 	= null<number>;			
			date flt1_eff_date		= start_date;
			number init_sprd 		= null(flt1_spread) ? 0 : flt1_spread;			

			if(null(flt1_notional) ) {
				if(!is_ccy)
					flt1_notional = flt2_notional;
				else
					flt1_notional = flt2_notional * flt2_fx_rate / flt1_fx_rate;
			}
			
			tenor_surface flt1_tenor_surface;
			try{
				/*if(!null(fwd_func_sprd_leg))
					flt1_tenor_surface = tenor_surface(trade_date, disc_func_sprd_leg,[fwd_func_sprd_leg],[flt1_ir_index],allow_extrap);
				else*/
					flt1_tenor_surface = tenor_surface(trade_date, flt1_disc_func,[flt1_fwd_disc_func],[flt1_ir_index],allow_extrap);
			}
			catch {
				flt1_tenor_surface = null<tenor_surface>;
			}
			
			//leg2
			number flt2_fix_proxy 	= null<number>;										
			date flt2_eff_date		= start_date;

			if(null(flt2_spread))
				flt2_spread = 0;
			
			tenor_surface flt2_tenor_surface;
			try{
				/*if(!null(fwd_func_flat_leg))
					flt2_tenor_surface = tenor_surface(trade_date, disc_func_flat_leg,[fwd_func_flat_leg],[flt2_ir_index],allow_extrap);
				else*/
					flt2_tenor_surface = tenor_surface(trade_date, flt2_disc_func,[flt2_fwd_disc_func],[flt2_ir_index],allow_extrap);
			}
			catch {
				flt2_tenor_surface = null<tenor_surface>;
			}
					
			
			if(!is_mtm) {//ex pv_in_sprd_leg=true --> flt1_fx_rate = 1, flt2_fx_rate = 1/1.4 = 0.714
				ql_ois_leg ois2 = ql_ois_leg(	ois2_def,"ois_leg2",trade_date,settle_date,start_date,maturity,mat_code,
										!flt1_pay,flt2_notional,flt2_eff_date,first_cpn_date,last_reg_date,flt2_spread,flt2_disc_func,	
										flt2_tenor_surface,cpn_roll_day,flt2_fx_rate,
										fixing_dates,fixing_rates,flt2_fix_proxy,allow_fwd_fix);

				ql_ois_leg ois1 = ql_ois_leg(ois1_def,"ois_leg1",trade_date,settle_date,start_date,maturity,mat_code,
													flt1_pay,flt1_notional,flt1_eff_date,first_cpn_date,last_reg_date,init_sprd,flt1_disc_func,	
													flt1_tenor_surface,cpn_roll_day,flt1_fx_rate,
													fixing_dates,fixing_rates,flt1_fix_proxy,allow_fwd_fix);

				ql_fixed_income_swap sw = ql_fixed_income_swap(ois1,ois2,instrument_name);

				if(null(flt1_spread)) {
					number flt_s	= sw.solver(0,swap_solver_code.SS_OIS_SPRD_LEG1,false);
					QL_FAIL_COND(null(flt_s),"error solving for spread", E_INIT);
					if(flt1_sprd_rnd_dec >= 0)
						flt_s = round(flt_s,flt1_sprd_rnd_dec);
					ois1 	= ql_ois_leg(ois1_def,"ois_leg1",trade_date,settle_date,start_date,maturity,mat_code,
											flt1_pay,flt1_notional,flt1_eff_date,first_cpn_date,last_reg_date,flt_s,flt1_disc_func,	
											flt1_tenor_surface,cpn_roll_day,flt1_fx_rate,
											fixing_dates,fixing_rates,flt1_fix_proxy,allow_fwd_fix);
					
					sw 		= ql_fixed_income_swap(ois1,ois2,instrument_name);

				}
				
				return swap_oisois(sw, error);
			}

			//mtm only from here
			ql_fixed_income_swap sw;
			
			if(!is_mtm_leg1){
			
				date flt_mtm_fx_spot_date 			= fx_spot_date; 
				number flt_mtm_fx_spot_LG2LG1		= flt2_fx_rate/flt1_fx_rate;//the fxrate that makes flatleg(LG2) equal to sprdleg(LG1) i.e. flatlegccy is baseccy
				disc_func flt_mtm_fx_df_LG2			= flt2_disc_func;//leg2 is flat leg and this disc_func is for the leg itself
				disc_func flt_mtm_fx_df_LG1			= flt1_disc_func;//disc_func for "other leg" = leg1 
				number flt_mtm_fx_not_LG1 			= flt1_notional;
				vector(date) flt_mtm_fx_fix_dates 	= null<vector(date)>;
				vector(number) flt_mtm_fx_fix 		= null<vector(number)>;
				number flt_mtm_fx_fix_proxy 		= flt_mtm_fx_spot_LG2LG1;
				logical flt_mtm_fx_fix_as_fwd 		= false;

				 ql_ois_leg ois2 	= ql_ois_leg(ois2_def,"ois_leg2",trade_date,settle_date,start_date,maturity,mat_code,
										!flt1_pay,flt2_notional,flt2_eff_date,first_cpn_date,last_reg_date,flt2_spread,flt2_disc_func,
										flt2_tenor_surface,cpn_roll_day,flt2_fx_rate,
										fixing_dates,fixing_rates,flt2_fix_proxy,allow_fwd_fix,
										flt_mtm_fx_spot_date, flt_mtm_fx_spot_LG2LG1,flt_mtm_fx_df_LG2,flt_mtm_fx_df_LG1,
										flt_mtm_fx_not_LG1,flt_mtm_fx_fix_dates,flt_mtm_fx_fix,flt_mtm_fx_fix_proxy,flt_mtm_fx_fix_as_fwd);

				ql_ois_leg ois1 	= ql_ois_leg(ois1_def,"ois_leg1",trade_date,settle_date,start_date,maturity,mat_code,
														flt1_pay,flt1_notional,flt1_eff_date,first_cpn_date,last_reg_date,init_sprd,flt1_disc_func,	
														flt1_tenor_surface,cpn_roll_day,flt1_fx_rate,
														fixing_dates,fixing_rates,flt1_fix_proxy,allow_fwd_fix);

				sw = ql_fixed_income_swap(ois1,ois2,instrument_name);

				if(null(flt1_spread)) {
					number flt_s	= sw.solver(0,swap_solver_code.SS_OIS_SPRD_LEG1,false);
					QL_FAIL_COND(null(flt_s),"error solving for spread", E_INIT);
					if(flt1_sprd_rnd_dec >= 0)
						flt_s = round(flt_s,flt1_sprd_rnd_dec);
					ois1 	= ql_ois_leg(ois1_def,"ois_leg1",trade_date,settle_date,start_date,maturity,mat_code,
											flt1_pay,flt1_notional,flt1_eff_date,first_cpn_date,last_reg_date,flt_s,flt1_disc_func,	
											flt1_tenor_surface,cpn_roll_day,flt1_fx_rate,
											fixing_dates,fixing_rates,flt1_fix_proxy,allow_fwd_fix);
					
					sw 		= ql_fixed_income_swap(ois1,ois2,instrument_name);

				}
				
				
			}

			else {
				ql_ois_leg ois2 = ql_ois_leg(ois2_def,"ois_leg2",trade_date,settle_date,start_date,maturity,mat_code,
											!flt1_pay,flt2_notional,flt2_eff_date,first_cpn_date,last_reg_date,flt2_spread,flt2_disc_func,	
											flt2_tenor_surface,cpn_roll_day,flt2_fx_rate,
											fixing_dates,fixing_rates,flt2_fix_proxy,allow_fwd_fix);

				date flt_mtm_fx_spot_date 			= fx_spot_date; 
				number flt_mtm_fx_spot_LG1LG2		= flt1_fx_rate/flt2_fx_rate;//the fxrate that makes flatleg(LG2) equal to sprdleg(LG1) i.e. flatlegccy is baseccy
				disc_func flt_mtm_fx_df_LG1			= flt1_disc_func;//leg2 is flat leg and this disc_func is for the leg itself
				disc_func flt_mtm_fx_df_LG2			= flt2_disc_func;//disc_func for "other leg" = leg2 
				number flt_mtm_fx_not_LG2 			= flt2_notional;
				vector(date) flt_mtm_fx_fix_dates 	= null<vector(date)>;
				vector(number) flt_mtm_fx_fix 		= null<vector(number)>;
				number flt_mtm_fx_fix_proxy 		= flt_mtm_fx_spot_LG1LG2;
				logical flt_mtm_fx_fix_as_fwd 		= false;

				ql_ois_leg ois1 	= ql_ois_leg(ois1_def,"ois_leg1",trade_date,settle_date,start_date,maturity,mat_code,
										flt1_pay,flt1_notional,flt1_eff_date,first_cpn_date,last_reg_date,init_sprd,flt1_disc_func,
										flt1_tenor_surface,cpn_roll_day,flt1_fx_rate,
										fixing_dates,fixing_rates,flt1_fix_proxy,allow_fwd_fix,
										flt_mtm_fx_spot_date, flt_mtm_fx_spot_LG1LG2,flt_mtm_fx_df_LG1,flt_mtm_fx_df_LG2,
										flt_mtm_fx_not_LG2,flt_mtm_fx_fix_dates,flt_mtm_fx_fix,flt_mtm_fx_fix_proxy,flt_mtm_fx_fix_as_fwd);

				sw = ql_fixed_income_swap(ois1,ois2,instrument_name);

				if(null(flt1_spread)) {
					number flt_s	= sw.solver(0,swap_solver_code.SS_OIS_SPRD_LEG1,false);
					QL_FAIL_COND(null(flt_s),"error solving for spread", E_INIT);
					if(flt1_sprd_rnd_dec >= 0)
						flt_s = round(flt_s,flt1_sprd_rnd_dec);
					ois1 	= ql_ois_leg(ois1_def,"ois_leg1",trade_date,settle_date,start_date,maturity,mat_code,
										flt1_pay,flt1_notional,flt1_eff_date,first_cpn_date,last_reg_date,flt_s,flt1_disc_func,
										flt1_tenor_surface,cpn_roll_day,flt1_fx_rate,
										fixing_dates,fixing_rates,flt1_fix_proxy,allow_fwd_fix,
										flt_mtm_fx_spot_date, flt_mtm_fx_spot_LG1LG2,flt_mtm_fx_df_LG1,flt_mtm_fx_df_LG2,
										flt_mtm_fx_not_LG2,flt_mtm_fx_fix_dates,flt_mtm_fx_fix,flt_mtm_fx_fix_proxy,flt_mtm_fx_fix_as_fwd);
					
					sw 		= ql_fixed_income_swap(ois1,ois2,instrument_name);

				}
				
			}

			return swap_oisois(sw, error);
			
		}
		catch {
			CORE_INT.catch_error_info(error,err.type(),err.message(), "swap_oisois_plain_int");
			return null<swap_oisois>;
		}
	}
}


/*-----------------------------------------------------------------------
  func: swap_oisois_plain
  minimal constructor for "screen"-swap, --> NO STUBS
  this version: disc_func input
  normally: leg1 = sprd_leg, leg2 = flat_leg
  ----------------------------------------------------------------------*/
swap_oisois swap_oisois_plain(	instr_def 					def,
								string 						instrument_name,	
								date option(nullable) 		trade_date,	
								date option(nullable) 		start_date,			//start_date has precedence over start_date_code
								string option(nullable) 	start_date_code,
								date option(nullable)		maturity,			//maturity has precedence over mat_code
								string 	option(nullable)	maturity_code,								
								number option(nullable)		notional_leg1,	//normally sprd_leg
								number 	 					notional_leg2,	//normally flat_leg
								number option(nullable)		spread_leg1 ,	//if null --> will be set to par
								number option(nullable)		spread_leg2 ,//if null --> will be 0
								logical 					pay_leg1,
								fx_spot option(nullable)	fx_sp,//OBS! fix this for the case when settle != spot date
								number option(nullable)		fx_quote,
								disc_func option(nullable) 	disc_func_leg1,
								disc_func option(nullable) 	fwd_disc_func_leg1,	
								//number option(nullable) 	curr_fix_sprd_leg,								
								disc_func option(nullable) 	disc_func_leg2,
								disc_func option(nullable) 	fwd_disc_func_leg2,																																												
								//number option(nullable) 	curr_fix_flat_leg,
								logical option(nullable)	pv_in_base_ccy,
								integer sprd_rnd_dec_leg1,
								error_info option(nullable) error = null<error_info>)
option (category: 'Instrument/Interest Rate Swap/ONIndex vs ONIndex')
{
	return CORE_INT_OISOIS.swap_oisois_plain_int(	def,instrument_name,trade_date,start_date,start_date_code,maturity,maturity_code,
											notional_leg1,notional_leg2,spread_leg1,spread_leg2 ,pay_leg1,fx_sp,fx_quote,
											disc_func_leg1, fwd_disc_func_leg1,
											disc_func_leg2, fwd_disc_func_leg2,
											pv_in_base_ccy,sprd_rnd_dec_leg1,error );
}

/*-----------------------------------------------------------------------
  func: swap_oisois_plain
  minimal constructor for single curr "screen"-swap,
  normally: leg1 = sprd_leg, leg2 = flat_leg
  ----------------------------------------------------------------------*/
swap_oisois swap_oisois_plain(	INSTR_TMPL.swap_oisois_def_tmpl	tmpl,
								string 						instrument_name,	
								date option(nullable) 		trade_date,	
								date option(nullable) 		start_date,//if tmpl have a code it is ignored
								date option(nullable)		maturity,//if tmpl have a code it is ignored									
								number option(nullable)		notional_leg1,
								number 	 					notional_leg2,
								number option(nullable)		spread_leg1 ,//if null --> will be set to par
								number option(nullable)		spread_leg2 ,//if null --> will be 0
								logical 					pay_leg1,																										
								fx_spot option(nullable)	fx_sp,//OBS! fix this for the case when settle != spot date
								number option(nullable)		fx_quote,
								disc_func option(nullable) 	disc_func_leg1,
								disc_func option(nullable) 	fwd_disc_func_leg1,															
								disc_func option(nullable) 	disc_func_leg2,
								disc_func option(nullable) 	fwd_disc_func_leg2,									
								logical option(nullable)	pv_in_base_ccy,
							    integer sprd_rnd_dec_leg1,
								error_info option(nullable) error = null<error_info>)
option (category: 'Instrument/Interest Rate Swap/ONIndex vs ONIndex')
{
	try{		
		instr_def def = instr_def_swap_oisois(tmpl,error);		
		if(!CORE_INT.check_instr_def(def))
			return null<swap_oisois>;
		return swap_oisois_plain(	def,instrument_name,trade_date,start_date,null<string>,
									maturity,null<string>,notional_leg1,notional_leg2,
									spread_leg1 ,spread_leg2,pay_leg1,fx_sp,fx_quote,
									disc_func_leg1,fwd_disc_func_leg1,
									disc_func_leg2,fwd_disc_func_leg2,pv_in_base_ccy,sprd_rnd_dec_leg1,error);

	}
	catch {
		CORE_INT.catch_error_info(error,err.type(),err.message(), "swap_oisois");
		return null<swap_oisois>;
	}
}